=== modified file 'TODO'
--- TODO	2019-02-13 08:45:09 +0000
+++ TODO	2019-02-09 23:31:44 +0000
@@ -14,7 +14,6 @@
 ** TODO [#C] Make start_mandos_communication() take "struct server".
 ** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 ** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -34,7 +33,6 @@
 
 * plymouth
 ** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
 
 * TODO [#B] passdev
 

=== modified file 'debian/changelog'
--- debian/changelog	2019-02-11 11:52:07 +0000
+++ debian/changelog	2019-02-11 06:31:42 +0000
@@ -1,10 +1,3 @@
-mandos (1.8.3-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_shlibdeps-arch): New; conditionally edit
-    debian/control before running dh_shlibdeps.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 11 Feb 2019 12:49:57 +0100
-
 mandos (1.8.3-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/rules'
--- debian/rules	2019-02-13 08:45:09 +0000
+++ debian/rules	2019-02-11 11:45:58 +0000
@@ -44,18 +44,15 @@
 
 override_dh_auto_test-arch: ;
 
-#bpo## dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
-#bpo## libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
-#bpo## alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
-#bpo## So we have to do this ugly hack to hide this build dependency if we
-#bpo## compiled with libgnutls30 << 3.6.0.
-#bpo#override_dh_shlibdeps-arch:
-#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
-#bpo#		--show libgnutls30); \
-#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-#bpo#		&& { cp --archive debian/control debian/control.orig; sed --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
-#bpo#	dh_shlibdeps
-#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
-#bpo#		--show libgnutls30); \
-#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-#bpo#		&& mv debian/control.orig debian/control
+# dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
+# libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
+# alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
+# So we have to do this ugly hack to hide this build dependency if we
+# compiled with libgnutls30 << 3.6.0.
+override_dh_shlibdeps-arch:
+	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
+		--show libgnutls30); \
+	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
+		&& sed --in-place --expression='s/libgnutls28-dev (>= 3\.6\.6) | //' debian/control
+	-grep libgnutls28 debian/control
+	dh_shlibdeps

=== modified file 'mandos-ctl'
--- mandos-ctl	2019-03-09 15:47:52 +0000
+++ mandos-ctl	2019-02-11 06:31:42 +0000
@@ -1,5 +1,5 @@
 #!/usr/bin/python
-# -*- mode: python; coding: utf-8; after-save-hook: (lambda () (let ((command (if (and (boundp 'tramp-file-name-structure) (string-match (car tramp-file-name-structure) (buffer-file-name))) (tramp-file-name-localname (tramp-dissect-file-name (buffer-file-name))) (buffer-file-name)))) (if (= (shell-command (format "%s --check" (shell-quote-argument command)) "*Test*") 0) (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w)) (kill-buffer "*Test*")) (display-buffer "*Test*")))); -*-
+# -*- mode: python; coding: utf-8 -*-
 #
 # Mandos Monitor - Control and monitor the Mandos server
 #
@@ -40,30 +40,37 @@
 import os
 import collections
 import json
-import unittest
-import logging
-import io
-import tempfile
-import contextlib
 
 import dbus
 
-# Show warnings by default
-if not sys.warnoptions:
-    import warnings
-    warnings.simplefilter("default")
-
-log = logging.getLogger(sys.argv[0])
-logging.basicConfig(level="INFO", # Show info level messages
-                    format="%(message)s") # Show basic log messages
-
-logging.captureWarnings(True)   # Show warnings via the logging system
-
 if sys.version_info.major == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
 
+tablewords = {
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "KeyID": "Key ID",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
+    "ExtendedTimeout": "Extended Timeout",
+    "Expires": "Expires",
+    "LastCheckerStatus": "Last Checker Status",
+}
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
 domain = "se.recompile"
 busname = domain + ".Mandos"
 server_path = "/"
@@ -96,8 +103,6 @@
     datetime.timedelta(0, 60)
     >>> rfc3339_duration_to_delta("PT60M")
     datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("P60M")
-    datetime.timedelta(1680)
     >>> rfc3339_duration_to_delta("PT24H")
     datetime.timedelta(1)
     >>> rfc3339_duration_to_delta("P1W")
@@ -106,35 +111,6 @@
     datetime.timedelta(0, 330)
     >>> rfc3339_duration_to_delta("P1DT3M20S")
     datetime.timedelta(1, 200)
-    >>> # Can not be empty:
-    >>> rfc3339_duration_to_delta("")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u''
-    >>> # Must start with "P":
-    >>> rfc3339_duration_to_delta("1D")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'1D'
-    >>> # Must use correct order
-    >>> rfc3339_duration_to_delta("PT1S2M")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'PT1S2M'
-    >>> # Time needs time marker
-    >>> rfc3339_duration_to_delta("P1H2S")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P1H2S'
-    >>> # Weeks can not be combined with anything else
-    >>> rfc3339_duration_to_delta("P1D2W")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P1D2W'
-    >>> rfc3339_duration_to_delta("P2W2H")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P2W2H'
     """
 
     # Parsing an RFC 3339 duration with regular expressions is not
@@ -218,39 +194,26 @@
 
 
 def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta"""
+    """Parse a string and return a datetime.timedelta
+
+    >>> string_to_delta('7d')
+    datetime.timedelta(7)
+    >>> string_to_delta('60s')
+    datetime.timedelta(0, 60)
+    >>> string_to_delta('60m')
+    datetime.timedelta(0, 3600)
+    >>> string_to_delta('24h')
+    datetime.timedelta(1)
+    >>> string_to_delta('1w')
+    datetime.timedelta(7)
+    >>> string_to_delta('5m 30s')
+    datetime.timedelta(0, 330)
+    """
 
     try:
         return rfc3339_duration_to_delta(interval)
-    except ValueError as e:
-        log.warning("%s - Parsing as pre-1.6.1 interval instead",
-                    ' '.join(e.args))
-    return parse_pre_1_6_1_interval(interval)
-
-
-def parse_pre_1_6_1_interval(interval):
-    """Parse an interval string as documented by Mandos before 1.6.1,
-    and return a datetime.timedelta
-
-    >>> parse_pre_1_6_1_interval('7d')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('60s')
-    datetime.timedelta(0, 60)
-    >>> parse_pre_1_6_1_interval('60m')
-    datetime.timedelta(0, 3600)
-    >>> parse_pre_1_6_1_interval('24h')
-    datetime.timedelta(1)
-    >>> parse_pre_1_6_1_interval('1w')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('5m 30s')
-    datetime.timedelta(0, 330)
-    >>> parse_pre_1_6_1_interval('')
-    datetime.timedelta(0)
-    >>> # Ignore unknown characters, allow any order and repetitions
-    >>> parse_pre_1_6_1_interval('2dxy7zz11y3m5m')
-    datetime.timedelta(2, 480, 18000)
-
-    """
+    except ValueError:
+        pass
 
     value = datetime.timedelta(0)
     regexp = re.compile(r"(\d+)([dsmhw]?)")
@@ -271,260 +234,53 @@
     return value
 
 
-## Classes for commands.
-
-# Abstract classes first
-class Command(object):
-    """Abstract class for commands"""
-    def run(self, mandos, mandos_objmgr, clients):
-        """Normal commands should implement run_on_one_client(), but
-        commands which want to operate on all clients at the same time
-        can override this run() method instead."""
-        self.mandos = mandos
-        for client, properties in clients.items():
-            self.run_on_one_client(client, properties)
-
-class PrintCmd(Command):
-    """Abstract class for commands printing client details"""
-    all_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
-                    "Created", "Interval", "Host", "KeyID",
-                    "Fingerprint", "CheckerRunning", "LastEnabled",
-                    "ApprovalPending", "ApprovedByDefault",
-                    "LastApprovalRequest", "ApprovalDelay",
-                    "ApprovalDuration", "Checker", "ExtendedTimeout",
-                    "Expires", "LastCheckerStatus")
-    def run(self, mandos, mandos_objmgr, clients):
-        print(self.output(mandos_objmgr, clients.values()))
-
-class PropertyCmd(Command):
-    """Abstract class for Actions for setting one client property"""
-    def run_on_one_client(self, client, properties):
-        """Set the Client's D-Bus property"""
-        log.debug("D-Bus: %s:%s:%s.Set(%r, %r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  self.property, self.value_to_set
-                  if not isinstance(self.value_to_set, dbus.Boolean)
-                  else bool(self.value_to_set))
-        client.Set(client_interface, self.property, self.value_to_set,
-                   dbus_interface=dbus.PROPERTIES_IFACE)
-
-class ValueArgumentMixIn(object):
-    """Mixin class for commands taking a value as argument"""
-    def __init__(self, value):
-        self.value_to_set = value
-
-class MillisecondsValueArgumentMixIn(ValueArgumentMixIn):
-    """Mixin class for commands taking a value argument as
-    milliseconds."""
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, convert value to a datetime.timedelta"""
-        self._vts = int(round(value.total_seconds() * 1000))
-
-# Actual (non-abstract) command classes
-
-class PrintTableCmd(PrintCmd):
-    def __init__(self, verbose=False):
-        self.verbose = verbose
-
-    def output(self, mandos_objmgr, clients):
-        default_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
-        keywords = default_keywords
-        if self.verbose:
-            keywords = self.all_keywords
-        return str(self.TableOfClients(clients, keywords))
-
-    class TableOfClients(object):
-        tableheaders = {
-            "Name": "Name",
-            "Enabled": "Enabled",
-            "Timeout": "Timeout",
-            "LastCheckedOK": "Last Successful Check",
-            "LastApprovalRequest": "Last Approval Request",
-            "Created": "Created",
-            "Interval": "Interval",
-            "Host": "Host",
-            "Fingerprint": "Fingerprint",
-            "KeyID": "Key ID",
-            "CheckerRunning": "Check Is Running",
-            "LastEnabled": "Last Enabled",
-            "ApprovalPending": "Approval Is Pending",
-            "ApprovedByDefault": "Approved By Default",
-            "ApprovalDelay": "Approval Delay",
-            "ApprovalDuration": "Approval Duration",
-            "Checker": "Checker",
-            "ExtendedTimeout": "Extended Timeout",
-            "Expires": "Expires",
-            "LastCheckerStatus": "Last Checker Status",
-        }
-
-        def __init__(self, clients, keywords, tableheaders=None):
-            self.clients = clients
-            self.keywords = keywords
-            if tableheaders is not None:
-                self.tableheaders = tableheaders
-
-        def __str__(self):
-            return "\n".join(self.rows())
-
-        if sys.version_info.major == 2:
-            __unicode__ = __str__
-            def __str__(self):
-                return str(self).encode(locale.getpreferredencoding())
-
-        def rows(self):
-            format_string = self.row_formatting_string()
-            rows = [self.header_line(format_string)]
-            rows.extend(self.client_line(client, format_string)
-                        for client in self.clients)
-            return rows
-
-        def row_formatting_string(self):
-            "Format string used to format table rows"
-            return " ".join("{{{key}:{width}}}".format(
-                width=max(len(self.tableheaders[key]),
-                          *(len(self.string_from_client(client, key))
-                            for client in self.clients)),
-                key=key)
-                            for key in self.keywords)
-
-        def string_from_client(self, client, key):
-            return self.valuetostring(client[key], key)
-
-        @staticmethod
-        def valuetostring(value, keyword):
-            if isinstance(value, dbus.Boolean):
-                return "Yes" if value else "No"
-            if keyword in ("Timeout", "Interval", "ApprovalDelay",
-                           "ApprovalDuration", "ExtendedTimeout"):
-                return milliseconds_to_string(value)
-            return str(value)
-
-        def header_line(self, format_string):
-            return format_string.format(**self.tableheaders)
-
-        def client_line(self, client, format_string):
-            return format_string.format(
-                **{key: self.string_from_client(client, key)
-                   for key in self.keywords})
-
-
-
-class DumpJSONCmd(PrintCmd):
-    def output(self, mandos_objmgr, clients):
-        data = {client["Name"]:
-                {key: self.dbus_boolean_to_bool(client[key])
-                 for key in self.all_keywords}
-                for client in clients.values()}
-        return json.dumps(data, indent=4, separators=(',', ': '))
-    @staticmethod
-    def dbus_boolean_to_bool(value):
-        if isinstance(value, dbus.Boolean):
-            value = bool(value)
-        return value
-
-class IsEnabledCmd(Command):
-    def run_on_one_client(self, client, properties):
-        if self.is_enabled(client, properties):
-            sys.exit(0)
-        sys.exit(1)
-    def is_enabled(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.Get(%r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  "Enabled")
-        return bool(client.Get(client_interface, "Enabled",
-                               dbus_interface=dbus.PROPERTIES_IFACE))
-
-class RemoveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.RemoveClient(%r)", busname,
-                  server_path, server_interface,
-                  str(client.__dbus_object_path__))
-        self.mandos.RemoveClient(client.__dbus_object_path__)
-
-class ApproveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(True)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(True),
-                       dbus_interface=client_interface)
-
-class DenyCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(False)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(False),
-                       dbus_interface=client_interface)
-
-class EnableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(True)
-
-class DisableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(False)
-
-class BumpTimeoutCmd(PropertyCmd):
-    property = "LastCheckedOK"
-    value_to_set = ""
-
-class StartCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(True)
-
-class StopCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(False)
-
-class ApproveByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(True)
-
-class DenyByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(False)
-
-class SetCheckerCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Checker"
-
-class SetHostCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Host"
-
-class SetSecretCmd(PropertyCmd, ValueArgumentMixIn):
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, read data from supplied file object"""
-        self._vts = value.read()
-        value.close()
-    property = "Secret"
-
-class SetTimeoutCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Timeout"
-
-class SetExtendedTimeoutCmd(PropertyCmd,
-                            MillisecondsValueArgumentMixIn):
-    property = "ExtendedTimeout"
-
-class SetIntervalCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Interval"
-
-class SetApprovalDelayCmd(PropertyCmd,
-                          MillisecondsValueArgumentMixIn):
-    property = "ApprovalDelay"
-
-class SetApprovalDurationCmd(PropertyCmd,
-                             MillisecondsValueArgumentMixIn):
-    property = "ApprovalDuration"
-
-def add_command_line_options(parser):
+def print_clients(clients, keywords):
+    def valuetostring(value, keyword):
+        if type(value) is dbus.Boolean:
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration", "ExtendedTimeout"):
+            return milliseconds_to_string(value)
+        return str(value)
+
+    # Create format string to print table rows
+    format_string = " ".join("{{{key}:{width}}}".format(
+        width=max(len(tablewords[key]),
+                  max(len(valuetostring(client[key], key))
+                      for client in clients)),
+        key=key)
+                             for key in keywords)
+    # Print header line
+    print(format_string.format(**tablewords))
+    for client in clients:
+        print(format_string
+              .format(**{key: valuetostring(client[key], key)
+                         for key in keywords}))
+
+
+def has_actions(options):
+    return any((options.enable,
+                options.disable,
+                options.bump_timeout,
+                options.start_checker,
+                options.stop_checker,
+                options.is_enabled,
+                options.remove,
+                options.checker is not None,
+                options.timeout is not None,
+                options.extended_timeout is not None,
+                options.interval is not None,
+                options.approved_by_default is not None,
+                options.approval_delay is not None,
+                options.approval_duration is not None,
+                options.host is not None,
+                options.secret is not None,
+                options.approve,
+                options.deny))
+
+
+def main():
+    parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
                         version="%(prog)s {}".format(version),
                         help="show version number and exit")
@@ -534,160 +290,50 @@
                         help="Print all fields")
     parser.add_argument("-j", "--dump-json", action="store_true",
                         help="Dump client data in JSON format")
-    enable_disable = parser.add_mutually_exclusive_group()
-    enable_disable.add_argument("-e", "--enable", action="store_true",
-                                help="Enable client")
-    enable_disable.add_argument("-d", "--disable",
-                                action="store_true",
-                                help="disable client")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
     parser.add_argument("-b", "--bump-timeout", action="store_true",
                         help="Bump timeout for client")
-    start_stop_checker = parser.add_mutually_exclusive_group()
-    start_stop_checker.add_argument("--start-checker",
-                                    action="store_true",
-                                    help="Start checker for client")
-    start_stop_checker.add_argument("--stop-checker",
-                                    action="store_true",
-                                    help="Stop checker for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
     parser.add_argument("-V", "--is-enabled", action="store_true",
                         help="Check if client is enabled")
     parser.add_argument("-r", "--remove", action="store_true",
                         help="Remove client")
     parser.add_argument("-c", "--checker",
                         help="Set checker command for client")
-    parser.add_argument("-t", "--timeout", type=string_to_delta,
+    parser.add_argument("-t", "--timeout",
                         help="Set timeout for client")
-    parser.add_argument("--extended-timeout", type=string_to_delta,
+    parser.add_argument("--extended-timeout",
                         help="Set extended timeout for client")
-    parser.add_argument("-i", "--interval", type=string_to_delta,
+    parser.add_argument("-i", "--interval",
                         help="Set checker interval for client")
-    approve_deny_default = parser.add_mutually_exclusive_group()
-    approve_deny_default.add_argument(
-        "--approve-by-default", action="store_true",
-        default=None, dest="approved_by_default",
-        help="Set client to be approved by default")
-    approve_deny_default.add_argument(
-        "--deny-by-default", action="store_false",
-        dest="approved_by_default",
-        help="Set client to be denied by default")
-    parser.add_argument("--approval-delay", type=string_to_delta,
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
                         help="Set delay before client approve/deny")
-    parser.add_argument("--approval-duration", type=string_to_delta,
+    parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
     parser.add_argument("-s", "--secret",
                         type=argparse.FileType(mode="rb"),
                         help="Set password blob (file) for client")
-    approve_deny = parser.add_mutually_exclusive_group()
-    approve_deny.add_argument(
-        "-A", "--approve", action="store_true",
-        help="Approve any current client request")
-    approve_deny.add_argument("-D", "--deny", action="store_true",
-                              help="Deny any current client request")
-    parser.add_argument("--debug", action="store_true",
-                        help="Debug mode (show D-Bus commands)")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
     parser.add_argument("--check", action="store_true",
                         help="Run self-test")
     parser.add_argument("client", nargs="*", help="Client name")
-
-
-def commands_from_options(options):
-
-    commands = []
-
-    if options.dump_json:
-        commands.append(DumpJSONCmd())
-
-    if options.enable:
-        commands.append(EnableCmd())
-
-    if options.disable:
-        commands.append(DisableCmd())
-
-    if options.bump_timeout:
-        commands.append(BumpTimeoutCmd())
-
-    if options.start_checker:
-        commands.append(StartCheckerCmd())
-
-    if options.stop_checker:
-        commands.append(StopCheckerCmd())
-
-    if options.is_enabled:
-        commands.append(IsEnabledCmd())
-
-    if options.checker is not None:
-        commands.append(SetCheckerCmd(options.checker))
-
-    if options.timeout is not None:
-        commands.append(SetTimeoutCmd(options.timeout))
-
-    if options.extended_timeout:
-        commands.append(
-            SetExtendedTimeoutCmd(options.extended_timeout))
-
-    if options.interval is not None:
-        commands.append(SetIntervalCmd(options.interval))
-
-    if options.approved_by_default is not None:
-        if options.approved_by_default:
-            commands.append(ApproveByDefaultCmd())
-        else:
-            commands.append(DenyByDefaultCmd())
-
-    if options.approval_delay is not None:
-        commands.append(SetApprovalDelayCmd(options.approval_delay))
-
-    if options.approval_duration is not None:
-        commands.append(
-            SetApprovalDurationCmd(options.approval_duration))
-
-    if options.host is not None:
-        commands.append(SetHostCmd(options.host))
-
-    if options.secret is not None:
-        commands.append(SetSecretCmd(options.secret))
-
-    if options.approve:
-        commands.append(ApproveCmd())
-
-    if options.deny:
-        commands.append(DenyCmd())
-
-    if options.remove:
-        commands.append(RemoveCmd())
-
-    # If no command option has been given, show table of clients,
-    # optionally verbosely
-    if not commands:
-        commands.append(PrintTableCmd(verbose=options.verbose))
-
-    return commands
-
-
-def check_option_syntax(parser, options):
-    """Apply additional restrictions on options, not expressible in
-argparse"""
-
-    def has_actions(options):
-        return any((options.enable,
-                    options.disable,
-                    options.bump_timeout,
-                    options.start_checker,
-                    options.stop_checker,
-                    options.is_enabled,
-                    options.remove,
-                    options.checker is not None,
-                    options.timeout is not None,
-                    options.extended_timeout is not None,
-                    options.interval is not None,
-                    options.approved_by_default is not None,
-                    options.approval_delay is not None,
-                    options.approval_duration is not None,
-                    options.host is not None,
-                    options.secret is not None,
-                    options.approve,
-                    options.deny))
+    options = parser.parse_args()
 
     if has_actions(options) and not (options.client or options.all):
         parser.error("Options require clients names or --all.")
@@ -698,36 +344,17 @@
         parser.error("--dump-json can only be used alone.")
     if options.all and not has_actions(options):
         parser.error("--all requires an action.")
-    if options.is_enabled and len(options.client) > 1:
-        parser.error("--is-enabled requires exactly one client")
-    if options.remove:
-        options.remove = False
-        if has_actions(options) and not options.deny:
-            parser.error("--remove can only be combined with --deny")
-        options.remove = True
-
-
-def main():
-    parser = argparse.ArgumentParser()
-
-    add_command_line_options(parser)
-
-    options = parser.parse_args()
-
-    check_option_syntax(parser, options)
-
-    clientnames = options.client
-
-    if options.debug:
-        log.setLevel(logging.DEBUG)
+
+    if options.check:
+        import doctest
+        fail_count, test_count = doctest.testmod()
+        sys.exit(os.EX_OK if fail_count == 0 else 1)
 
     try:
         bus = dbus.SystemBus()
-        log.debug("D-Bus: Connect to: (name=%r, path=%r)", busname,
-                  server_path)
         mandos_dbus_objc = bus.get_object(busname, server_path)
     except dbus.exceptions.DBusException:
-        log.critical("Could not connect to Mandos server")
+        print("Could not connect to Mandos server", file=sys.stderr)
         sys.exit(1)
 
     mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -735,806 +362,137 @@
     mandos_serv_object_manager = dbus.Interface(
         mandos_dbus_objc, dbus_interface=dbus.OBJECT_MANAGER_IFACE)
 
-    # Filter out log message from dbus module
-    dbus_logger = logging.getLogger("dbus.proxies")
-    class NullFilter(logging.Filter):
-        def filter(self, record):
-            return False
-    dbus_filter = NullFilter()
+    # block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
     try:
-        dbus_logger.addFilter(dbus_filter)
-        log.debug("D-Bus: %s:%s:%s.GetManagedObjects()", busname,
-                  server_path, dbus.OBJECT_MANAGER_IFACE)
-        mandos_clients = {path: ifs_and_props[client_interface]
-                          for path, ifs_and_props in
-                          mandos_serv_object_manager
-                          .GetManagedObjects().items()
-                          if client_interface in ifs_and_props}
+        try:
+            mandos_clients = {path: ifs_and_props[client_interface]
+                              for path, ifs_and_props in
+                              mandos_serv_object_manager
+                              .GetManagedObjects().items()
+                              if client_interface in ifs_and_props}
+        finally:
+            # restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
     except dbus.exceptions.DBusException as e:
-        log.critical("Failed to access Mandos server through D-Bus:"
-                     "\n%s", e)
+        print("Access denied: "
+              "Accessing mandos server through D-Bus: {}".format(e),
+              file=sys.stderr)
         sys.exit(1)
-    finally:
-        # restore dbus logger
-        dbus_logger.removeFilter(dbus_filter)
 
     # Compile dict of (clients: properties) to process
     clients = {}
 
-    if not clientnames:
+    if options.all or not options.client:
         clients = {bus.get_object(busname, path): properties
                    for path, properties in mandos_clients.items()}
     else:
-        for name in clientnames:
+        for name in options.client:
             for path, client in mandos_clients.items():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                log.critical("Client not found on server: %r", name)
+                print("Client not found on server: {!r}"
+                      .format(name), file=sys.stderr)
                 sys.exit(1)
 
-    # Run all commands on clients
-    commands = commands_from_options(options)
-    for command in commands:
-        command.run(mandos_serv, mandos_serv_object_manager, clients)
-
-
-class Test_milliseconds_to_string(unittest.TestCase):
-    def test_all(self):
-        self.assertEqual(milliseconds_to_string(93785000),
-                         "1T02:03:05")
-    def test_no_days(self):
-        self.assertEqual(milliseconds_to_string(7385000), "02:03:05")
-    def test_all_zero(self):
-        self.assertEqual(milliseconds_to_string(0), "00:00:00")
-    def test_no_fractional_seconds(self):
-        self.assertEqual(milliseconds_to_string(400), "00:00:00")
-        self.assertEqual(milliseconds_to_string(900), "00:00:00")
-        self.assertEqual(milliseconds_to_string(1900), "00:00:01")
-
-class Test_string_to_delta(unittest.TestCase):
-    def test_handles_basic_rfc3339(self):
-        self.assertEqual(string_to_delta("PT0S"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("P0D"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("PT1S"),
-                         datetime.timedelta(0, 1))
-        self.assertEqual(string_to_delta("PT2H"),
-                         datetime.timedelta(0, 7200))
-    def test_falls_back_to_pre_1_6_1_with_warning(self):
-        # assertLogs only exists in Python 3.4
-        if hasattr(self, "assertLogs"):
-            with self.assertLogs(log, logging.WARNING):
-                value = string_to_delta("2h")
-        else:
-            class WarningFilter(logging.Filter):
-                """Don't show, but record the presence of, warnings"""
-                def filter(self, record):
-                    is_warning = record.levelno >= logging.WARNING
-                    self.found = is_warning or getattr(self, "found",
-                                                       False)
-                    return not is_warning
-            warning_filter = WarningFilter()
-            log.addFilter(warning_filter)
-            try:
-                value = string_to_delta("2h")
-            finally:
-                log.removeFilter(warning_filter)
-            self.assertTrue(getattr(warning_filter, "found", False))
-        self.assertEqual(value, datetime.timedelta(0, 7200))
-
-
-class TestCmd(unittest.TestCase):
-    """Abstract class for tests of command classes"""
-    def setUp(self):
-        testcase = self
-        class MockClient(object):
-            def __init__(self, name, **attributes):
-                self.__dbus_object_path__ = "objpath_{}".format(name)
-                self.attributes = attributes
-                self.attributes["Name"] = name
-                self.calls = []
-            def Set(self, interface, property, value, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                self.attributes[property] = value
-            def Get(self, interface, property, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                return self.attributes[property]
-            def Approve(self, approve, dbus_interface):
-                testcase.assertEqual(dbus_interface, client_interface)
-                self.calls.append(("Approve", (approve,
-                                               dbus_interface)))
-        self.client = MockClient(
-            "foo",
-            KeyID=("92ed150794387c03ce684574b1139a65"
-                   "94a34f895daaaf09fd8ea90a27cddb12"),
-            Secret=b"secret",
-            Host="foo.example.org",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-03T00:00:00",
-            Created="2019-01-02T00:00:00",
-            Interval=120000,
-            Fingerprint=("778827225BA7DE539C5A"
-                         "7CFA59CFF7CDBD9A5920"),
-            CheckerRunning=dbus.Boolean(False),
-            LastEnabled="2019-01-03T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(True),
-            LastApprovalRequest="",
-            ApprovalDelay=0,
-            ApprovalDuration=1000,
-            Checker="fping -q -- %(host)s",
-            ExtendedTimeout=900000,
-            Expires="2019-02-04T00:00:00",
-            LastCheckerStatus=0)
-        self.other_client = MockClient(
-            "barbar",
-            KeyID=("0558568eedd67d622f5c83b35a115f79"
-                   "6ab612cff5ad227247e46c2b020f441c"),
-            Secret=b"secretbar",
-            Host="192.0.2.3",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-04T00:00:00",
-            Created="2019-01-03T00:00:00",
-            Interval=120000,
-            Fingerprint=("3E393AEAEFB84C7E89E2"
-                         "F547B3A107558FCA3A27"),
-            CheckerRunning=dbus.Boolean(True),
-            LastEnabled="2019-01-04T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(False),
-            LastApprovalRequest="2019-01-03T00:00:00",
-            ApprovalDelay=30000,
-            ApprovalDuration=1000,
-            Checker=":",
-            ExtendedTimeout=900000,
-            Expires="2019-02-05T00:00:00",
-            LastCheckerStatus=-2)
-        self.clients =  collections.OrderedDict(
-            [
-                (self.client, self.client.attributes),
-                (self.other_client, self.other_client.attributes),
-            ])
-        self.one_client = {self.client: self.client.attributes}
-
-class TestPrintTableCmd(TestCmd):
-    def test_normal(self):
-        output = PrintTableCmd().output(None, self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check
-foo    Yes     00:05:00 2019-02-03T00:00:00  
-barbar Yes     00:05:00 2019-02-04T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_verbose(self):
-        output = PrintTableCmd(verbose=True).output(
-            None, self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check Created             Interval Host            Key ID                                                           Fingerprint                              Check Is Running Last Enabled        Approval Is Pending Approved By Default Last Approval Request Approval Delay Approval Duration Checker              Extended Timeout Expires             Last Checker Status
-foo    Yes     00:05:00 2019-02-03T00:00:00   2019-01-02T00:00:00 00:02:00 foo.example.org 92ed150794387c03ce684574b1139a6594a34f895daaaf09fd8ea90a27cddb12 778827225BA7DE539C5A7CFA59CFF7CDBD9A5920 No               2019-01-03T00:00:00 No                  Yes                                       00:00:00       00:00:01          fping -q -- %(host)s 00:15:00         2019-02-04T00:00:00 0                  
-barbar Yes     00:05:00 2019-02-04T00:00:00   2019-01-03T00:00:00 00:02:00 192.0.2.3       0558568eedd67d622f5c83b35a115f796ab612cff5ad227247e46c2b020f441c 3E393AEAEFB84C7E89E2F547B3A107558FCA3A27 Yes              2019-01-04T00:00:00 No                  No                  2019-01-03T00:00:00   00:00:30       00:00:01          :                    00:15:00         2019-02-05T00:00:00 -2                 
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_one_client(self):
-        output = PrintTableCmd().output(None, self.one_client.values())
-        expected_output = """
-Name Enabled Timeout  Last Successful Check
-foo  Yes     00:05:00 2019-02-03T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-
-class TestDumpJSONCmd(TestCmd):
-    def setUp(self):
-        self.expected_json = {
-            "foo": {
-                "Name": "foo",
-                "KeyID": ("92ed150794387c03ce684574b1139a65"
-                          "94a34f895daaaf09fd8ea90a27cddb12"),
-                "Host": "foo.example.org",
-                "Enabled": True,
-                "Timeout": 300000,
-                "LastCheckedOK": "2019-02-03T00:00:00",
-                "Created": "2019-01-02T00:00:00",
-                "Interval": 120000,
-                "Fingerprint": ("778827225BA7DE539C5A"
-                                "7CFA59CFF7CDBD9A5920"),
-                "CheckerRunning": False,
-                "LastEnabled": "2019-01-03T00:00:00",
-                "ApprovalPending": False,
-                "ApprovedByDefault": True,
-                "LastApprovalRequest": "",
-                "ApprovalDelay": 0,
-                "ApprovalDuration": 1000,
-                "Checker": "fping -q -- %(host)s",
-                "ExtendedTimeout": 900000,
-                "Expires": "2019-02-04T00:00:00",
-                "LastCheckerStatus": 0,
-            },
-            "barbar": {
-                "Name": "barbar",
-                "KeyID": ("0558568eedd67d622f5c83b35a115f79"
-                          "6ab612cff5ad227247e46c2b020f441c"),
-                "Host": "192.0.2.3",
-                "Enabled": True,
-                "Timeout": 300000,
-                "LastCheckedOK": "2019-02-04T00:00:00",
-                "Created": "2019-01-03T00:00:00",
-                "Interval": 120000,
-                "Fingerprint": ("3E393AEAEFB84C7E89E2"
-                                "F547B3A107558FCA3A27"),
-                "CheckerRunning": True,
-                "LastEnabled": "2019-01-04T00:00:00",
-                "ApprovalPending": False,
-                "ApprovedByDefault": False,
-                "LastApprovalRequest": "2019-01-03T00:00:00",
-                "ApprovalDelay": 30000,
-                "ApprovalDuration": 1000,
-                "Checker": ":",
-                "ExtendedTimeout": 900000,
-                "Expires": "2019-02-05T00:00:00",
-                "LastCheckerStatus": -2,
-            },
-        }
-        return super(TestDumpJSONCmd, self).setUp()
-    def test_normal(self):
-        json_data = json.loads(DumpJSONCmd().output(None,
-                                                    self.clients))
-        self.assertDictEqual(json_data, self.expected_json)
-    def test_one_client(self):
-        clients = self.one_client
-        json_data = json.loads(DumpJSONCmd().output(None, clients))
-        expected_json = {"foo": self.expected_json["foo"]}
-        self.assertDictEqual(json_data, expected_json)
-
-class TestIsEnabledCmd(TestCmd):
-    def test_is_enabled(self):
-        self.assertTrue(all(IsEnabledCmd().is_enabled(client, properties)
-                            for client, properties in self.clients.items()))
-    def test_is_enabled_run_exits_successfully(self):
-        with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, None, self.one_client)
-        if e.exception.code is not None:
-            self.assertEqual(e.exception.code, 0)
-        else:
-            self.assertIsNone(e.exception.code)
-    def test_is_enabled_run_exits_with_failure(self):
-        self.client.attributes["Enabled"] = dbus.Boolean(False)
-        with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, None, self.one_client)
-        if isinstance(e.exception.code, int):
-            self.assertNotEqual(e.exception.code, 0)
-        else:
-            self.assertIsNotNone(e.exception.code)
-
-class TestRemoveCmd(TestCmd):
-    def test_remove(self):
-        class MockMandos(object):
-            def __init__(self):
-                self.calls = []
-            def RemoveClient(self, dbus_path):
-                self.calls.append(("RemoveClient", (dbus_path,)))
-        mandos = MockMandos()
-        super(TestRemoveCmd, self).setUp()
-        RemoveCmd().run(mandos, None, self.clients)
-        self.assertEqual(len(mandos.calls), 2)
-        for client in self.clients:
-            self.assertIn(("RemoveClient",
-                           (client.__dbus_object_path__,)),
-                          mandos.calls)
-
-class TestApproveCmd(TestCmd):
-    def test_approve(self):
-        ApproveCmd().run(None, None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (True, client_interface)),
-                          client.calls)
-
-class TestDenyCmd(TestCmd):
-    def test_deny(self):
-        DenyCmd().run(None, None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (False, client_interface)),
-                          client.calls)
-
-class TestEnableCmd(TestCmd):
-    def test_enable(self):
-        for client in self.clients:
-            client.attributes["Enabled"] = False
-
-        EnableCmd().run(None, None, self.clients)
-
-        for client in self.clients:
-            self.assertTrue(client.attributes["Enabled"])
-
-class TestDisableCmd(TestCmd):
-    def test_disable(self):
-        DisableCmd().run(None, None, self.clients)
-
-        for client in self.clients:
-            self.assertFalse(client.attributes["Enabled"])
-
-class Unique(object):
-    """Class for objects which exist only to be unique objects, since
-unittest.mock.sentinel only exists in Python 3.3"""
-
-class TestPropertyCmd(TestCmd):
-    """Abstract class for tests of PropertyCmd classes"""
-    def runTest(self):
-        if not hasattr(self, "command"):
-            return
-        values_to_get = getattr(self, "values_to_get",
-                                self.values_to_set)
-        for value_to_set, value_to_get in zip(self.values_to_set,
-                                              values_to_get):
-            for client in self.clients:
-                old_value = client.attributes[self.property]
-                self.assertNotIsInstance(old_value, Unique)
-                client.attributes[self.property] = Unique()
-            self.run_command(value_to_set, self.clients)
-            for client in self.clients:
-                value = client.attributes[self.property]
-                self.assertNotIsInstance(value, Unique)
-                self.assertEqual(value, value_to_get)
-    def run_command(self, value, clients):
-        self.command().run(None, None, clients)
-
-class TestBumpTimeoutCmd(TestPropertyCmd):
-    command = BumpTimeoutCmd
-    property = "LastCheckedOK"
-    values_to_set = [""]
-
-class TestStartCheckerCmd(TestPropertyCmd):
-    command = StartCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestStopCheckerCmd(TestPropertyCmd):
-    command = StopCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestApproveByDefaultCmd(TestPropertyCmd):
-    command = ApproveByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestDenyByDefaultCmd(TestPropertyCmd):
-    command = DenyByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestValueArgumentPropertyCmd(TestPropertyCmd):
-    """Abstract class for tests of PropertyCmd classes using the
-ValueArgumentMixIn"""
-    def runTest(self):
-        if type(self) is TestValueArgumentPropertyCmd:
-            return
-        return super(TestValueArgumentPropertyCmd, self).runTest()
-    def run_command(self, value, clients):
-        self.command(value).run(None, None, clients)
-
-class TestSetCheckerCmd(TestValueArgumentPropertyCmd):
-    command = SetCheckerCmd
-    property = "Checker"
-    values_to_set = ["", ":", "fping -q -- %s"]
-
-class TestSetHostCmd(TestValueArgumentPropertyCmd):
-    command = SetHostCmd
-    property = "Host"
-    values_to_set = ["192.0.2.3", "foo.example.org"]
-
-class TestSetSecretCmd(TestValueArgumentPropertyCmd):
-    command = SetSecretCmd
-    property = "Secret"
-    values_to_set = [io.BytesIO(b""),
-                     io.BytesIO(b"secret\0xyzzy\nbar")]
-    values_to_get = [b"", b"secret\0xyzzy\nbar"]
-
-class TestSetTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetTimeoutCmd
-    property = "Timeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetExtendedTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetExtendedTimeoutCmd
-    property = "ExtendedTimeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetIntervalCmd(TestValueArgumentPropertyCmd):
-    command = SetIntervalCmd
-    property = "Interval"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDelayCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDelayCmd
-    property = "ApprovalDelay"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDurationCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDurationCmd
-    property = "ApprovalDuration"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class Test_command_from_options(unittest.TestCase):
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-    def assert_command_from_args(self, args, command_cls, **cmd_attrs):
-        """Assert that parsing ARGS should result in an instance of
-COMMAND_CLS with (optionally) all supplied attributes (CMD_ATTRS)."""
-        options = self.parser.parse_args(args)
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 1)
-        command = commands[0]
-        self.assertIsInstance(command, command_cls)
-        for key, value in cmd_attrs.items():
-            self.assertEqual(getattr(command, key), value)
-    def test_print_table(self):
-        self.assert_command_from_args([], PrintTableCmd,
-                                      verbose=False)
-
-    def test_print_table_verbose(self):
-        self.assert_command_from_args(["--verbose"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_print_table_verbose_short(self):
-        self.assert_command_from_args(["-v"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_enable(self):
-        self.assert_command_from_args(["--enable", "foo"], EnableCmd)
-
-    def test_enable_short(self):
-        self.assert_command_from_args(["-e", "foo"], EnableCmd)
-
-    def test_disable(self):
-        self.assert_command_from_args(["--disable", "foo"],
-                                      DisableCmd)
-
-    def test_disable_short(self):
-        self.assert_command_from_args(["-d", "foo"], DisableCmd)
-
-    def test_bump_timeout(self):
-        self.assert_command_from_args(["--bump-timeout", "foo"],
-                                      BumpTimeoutCmd)
-
-    def test_bump_timeout_short(self):
-        self.assert_command_from_args(["-b", "foo"], BumpTimeoutCmd)
-
-    def test_start_checker(self):
-        self.assert_command_from_args(["--start-checker", "foo"],
-                                      StartCheckerCmd)
-
-    def test_stop_checker(self):
-        self.assert_command_from_args(["--stop-checker", "foo"],
-                                      StopCheckerCmd)
-
-    def test_remove(self):
-        self.assert_command_from_args(["--remove", "foo"],
-                                      RemoveCmd)
-
-    def test_remove_short(self):
-        self.assert_command_from_args(["-r", "foo"], RemoveCmd)
-
-    def test_checker(self):
-        self.assert_command_from_args(["--checker", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_checker_empty(self):
-        self.assert_command_from_args(["--checker", "", "foo"],
-                                      SetCheckerCmd, value_to_set="")
-
-    def test_checker_short(self):
-        self.assert_command_from_args(["-c", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_timeout(self):
-        self.assert_command_from_args(["--timeout", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_timeout_short(self):
-        self.assert_command_from_args(["-t", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_extended_timeout(self):
-        self.assert_command_from_args(["--extended-timeout", "PT15M",
-                                       "foo"],
-                                      SetExtendedTimeoutCmd,
-                                      value_to_set=900000)
-
-    def test_interval(self):
-        self.assert_command_from_args(["--interval", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_interval_short(self):
-        self.assert_command_from_args(["-i", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_approve_by_default(self):
-        self.assert_command_from_args(["--approve-by-default", "foo"],
-                                      ApproveByDefaultCmd)
-
-    def test_deny_by_default(self):
-        self.assert_command_from_args(["--deny-by-default", "foo"],
-                                      DenyByDefaultCmd)
-
-    def test_approval_delay(self):
-        self.assert_command_from_args(["--approval-delay", "PT30S",
-                                       "foo"], SetApprovalDelayCmd,
-                                      value_to_set=30000)
-
-    def test_approval_duration(self):
-        self.assert_command_from_args(["--approval-duration", "PT1S",
-                                       "foo"], SetApprovalDurationCmd,
-                                      value_to_set=1000)
-
-    def test_host(self):
-        self.assert_command_from_args(["--host", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_host_short(self):
-        self.assert_command_from_args(["-H", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_secret_devnull(self):
-        self.assert_command_from_args(["--secret", os.path.devnull,
-                                       "foo"], SetSecretCmd,
-                                      value_to_set=b"")
-
-    def test_secret_tempfile(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["--secret", f.name,
-                                           "foo"], SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_secret_devnull_short(self):
-        self.assert_command_from_args(["-s", os.path.devnull, "foo"],
-                                      SetSecretCmd, value_to_set=b"")
-
-    def test_secret_tempfile_short(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["-s", f.name, "foo"],
-                                          SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_approve(self):
-        self.assert_command_from_args(["--approve", "foo"],
-                                      ApproveCmd)
-
-    def test_approve_short(self):
-        self.assert_command_from_args(["-A", "foo"], ApproveCmd)
-
-    def test_deny(self):
-        self.assert_command_from_args(["--deny", "foo"], DenyCmd)
-
-    def test_deny_short(self):
-        self.assert_command_from_args(["-D", "foo"], DenyCmd)
-
-    def test_dump_json(self):
-        self.assert_command_from_args(["--dump-json"], DumpJSONCmd)
-
-    def test_is_enabled(self):
-        self.assert_command_from_args(["--is-enabled", "foo"],
-                                      IsEnabledCmd)
-
-    def test_is_enabled_short(self):
-        self.assert_command_from_args(["-V", "foo"], IsEnabledCmd)
-
-    def test_deny_before_remove(self):
-        options = self.parser.parse_args(["--deny", "--remove", "foo"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-    def test_deny_before_remove_reversed(self):
-        options = self.parser.parse_args(["--remove", "--deny", "--all"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-
-class Test_check_option_syntax(unittest.TestCase):
-    # This mostly corresponds to the definition from has_actions() in
-    # check_option_syntax()
-    actions = {
-        # The actual values set here are not that important, but we do
-        # at least stick to the correct types, even though they are
-        # never used
-        "enable": True,
-        "disable": True,
-        "bump_timeout": True,
-        "start_checker": True,
-        "stop_checker": True,
-        "is_enabled": True,
-        "remove": True,
-        "checker": "x",
-        "timeout": datetime.timedelta(),
-        "extended_timeout": datetime.timedelta(),
-        "interval": datetime.timedelta(),
-        "approved_by_default": True,
-        "approval_delay": datetime.timedelta(),
-        "approval_duration": datetime.timedelta(),
-        "host": "x",
-        "secret": io.BytesIO(b"x"),
-        "approve": True,
-        "deny": True,
-    }
-
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-
-    @contextlib.contextmanager
-    def assertParseError(self):
-        with self.assertRaises(SystemExit) as e:
-            with self.temporarily_suppress_stderr():
-                yield
-        # Exit code from argparse is guaranteed to be "2".  Reference:
-        # https://docs.python.org/3/library/argparse.html#exiting-methods
-        self.assertEqual(e.exception.code, 2)
-
-    @staticmethod
-    @contextlib.contextmanager
-    def temporarily_suppress_stderr():
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            yield
-        finally:
-            # restore stderr
-            os.dup2(stderrcopy, sys.stderr.fileno())
-            os.close(stderrcopy)
-
-    def check_option_syntax(self, options):
-        check_option_syntax(self.parser, options)
-
-    def test_actions_requires_client_or_all(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_actions_conflicts_with_verbose(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.verbose = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_verbose(self):
-        options = self.parser.parse_args()
-        options.dump_json = True
-        options.verbose = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.dump_json = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_all_can_not_be_alone(self):
-        options = self.parser.parse_args()
-        options.all = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_all_is_ok_with_any_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            self.check_option_syntax(options)
-
-    def test_is_enabled_fails_without_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_is_enabled_works_with_one_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo"]
-        self.check_option_syntax(options)
-
-    def test_is_enabled_fails_with_two_clients(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo", "barbar"]
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_remove_can_only_be_combined_with_action_deny(self):
-        for action, value in self.actions.items():
-            if action in {"remove", "deny"}:
-                continue
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            options.remove = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-
-
-def should_only_run_tests():
-    parser = argparse.ArgumentParser(add_help=False)
-    parser.add_argument("--check", action='store_true')
-    args, unknown_args = parser.parse_known_args()
-    run_tests = args.check
-    if run_tests:
-        # Remove --check argument from sys.argv
-        sys.argv[1:] = unknown_args
-    return run_tests
-
-# Add all tests from doctest strings
-def load_tests(loader, tests, none):
-    import doctest
-    tests.addTests(doctest.DocTestSuite())
-    return tests
+    if not has_actions(options) and clients:
+        if options.verbose or options.dump_json:
+            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "KeyID",
+                        "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault", "LastApprovalRequest",
+                        "ApprovalDelay", "ApprovalDuration",
+                        "Checker", "ExtendedTimeout", "Expires",
+                        "LastCheckerStatus")
+        else:
+            keywords = defaultkeywords
+
+        if options.dump_json:
+            json.dump({client["Name"]: {key:
+                                        bool(client[key])
+                                        if isinstance(client[key],
+                                                      dbus.Boolean)
+                                        else client[key]
+                                        for key in keywords}
+                       for client in clients.values()},
+                      fp=sys.stdout, indent=4,
+                      separators=(',', ': '))
+            print()
+        else:
+            print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+
+            def set_client_prop(prop, value):
+                """Set a Client D-Bus property"""
+                client.Set(client_interface, prop, value,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+
+            def set_client_prop_ms(prop, value):
+                """Set a Client D-Bus property, converted
+                from a string to milliseconds."""
+                set_client_prop(prop,
+                                string_to_delta(value).total_seconds()
+                                * 1000)
+
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                set_client_prop("Enabled", dbus.Boolean(True))
+            if options.disable:
+                set_client_prop("Enabled", dbus.Boolean(False))
+            if options.bump_timeout:
+                set_client_prop("LastCheckedOK", "")
+            if options.start_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(True))
+            if options.stop_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(False))
+            if options.is_enabled:
+                if client.Get(client_interface, "Enabled",
+                              dbus_interface=dbus.PROPERTIES_IFACE):
+                    sys.exit(0)
+                else:
+                    sys.exit(1)
+            if options.checker is not None:
+                set_client_prop("Checker", options.checker)
+            if options.host is not None:
+                set_client_prop("Host", options.host)
+            if options.interval is not None:
+                set_client_prop_ms("Interval", options.interval)
+            if options.approval_delay is not None:
+                set_client_prop_ms("ApprovalDelay",
+                                   options.approval_delay)
+            if options.approval_duration is not None:
+                set_client_prop_ms("ApprovalDuration",
+                                   options.approval_duration)
+            if options.timeout is not None:
+                set_client_prop_ms("Timeout", options.timeout)
+            if options.extended_timeout is not None:
+                set_client_prop_ms("ExtendedTimeout",
+                                   options.extended_timeout)
+            if options.secret is not None:
+                set_client_prop("Secret",
+                                dbus.ByteArray(options.secret.read()))
+            if options.approved_by_default is not None:
+                set_client_prop("ApprovedByDefault",
+                                dbus.Boolean(options
+                                             .approved_by_default))
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
+
 
 if __name__ == "__main__":
-    if should_only_run_tests():
-        # Call using ./tdd-python-script --check [--verbose]
-        unittest.main()
-    else:
-        main()
+    main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2019-03-08 23:55:34 +0000
+++ mandos-ctl.xml	2019-02-10 04:20:26 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2019-03-09">
+<!ENTITY TIMESTAMP "2019-02-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -62,22 +62,6 @@
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
-      <group>
-	  <arg choice="plain"><option>--verbose</option></arg>
-	  <arg choice="plain"><option>-v</option></arg>
-	  <sbr/>
-	  <arg choice="plain"><option>--dump-json</option></arg>
-	  <arg choice="plain"><option>-j</option></arg>
-      </group>
-      <arg><option>--debug</option></arg>
-      <group>
-	<arg rep='repeat' choice='plain'>
-	  <replaceable>CLIENT</replaceable>
-	</arg>
-      </group>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
       <group choice="req">
 	<group>
 	  <arg choice="plain"><option>--enable</option></arg>
@@ -94,10 +78,18 @@
 	<sbr/>
 	<group>
 	  <arg choice="plain"><option>--start-checker</option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--stop-checker</option></arg>
 	</group>
 	<sbr/>
 	<group>
+	  <arg choice="plain"><option>--remove</option></arg>
+	  <arg choice="plain"><option>-r</option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--checker
 	  <replaceable>COMMAND</replaceable></option></arg>
 	  <arg choice="plain"><option>-c
@@ -141,6 +133,13 @@
 	</group>
 	<sbr/>
 	<group>
+	  <arg choice="plain"><option>--interval
+	  <replaceable>TIME</replaceable></option></arg>
+	  <arg choice="plain"><option>-i
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--host
 	  <replaceable>STRING</replaceable></option></arg>
 	  <arg choice="plain"><option>-H
@@ -163,7 +162,6 @@
 	</group>
       </group>
       <sbr/>
-      <arg><option>--debug</option></arg>
       <group choice="req">
 	<arg choice="plain"><option>--all</option></arg>
 	<arg choice="plain"><option>-a</option></arg>
@@ -175,18 +173,13 @@
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
       <group>
-	<arg choice="plain"><option>--deny</option></arg>
-	<arg choice="plain"><option>-D</option></arg>
-      </group>
-      <group choice="req">
-	  <arg choice="plain"><option>--remove</option></arg>
-	  <arg choice="plain"><option>-r</option></arg>
-      </group>
-      <sbr/>
-      <arg><option>--debug</option></arg>
-      <group choice="req">
-	<arg choice="plain"><option>--all</option></arg>
-	<arg choice="plain"><option>-a</option></arg>
+	  <arg choice="plain"><option>--verbose</option></arg>
+	  <arg choice="plain"><option>-v</option></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--dump-json</option></arg>
+	  <arg choice="plain"><option>-j</option></arg>
+      </group>
+      <group>
 	<arg rep='repeat' choice='plain'>
 	  <replaceable>CLIENT</replaceable>
 	</arg>
@@ -198,7 +191,6 @@
 	<arg choice="plain"><option>--is-enabled</option></arg>
 	<arg choice="plain"><option>-V</option></arg>
       </group>
-      <arg><option>--debug</option></arg>
       <arg choice='plain'><replaceable>CLIENT</replaceable></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -512,15 +504,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--debug</option></term>
-	<listitem>
-	  <para>
-	    Show debug output; currently, this means show D-Bus calls.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--check</option></term>
 	<listitem>
 	  <para>
@@ -598,7 +581,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --timeout="PT5M" --interval="PT1M" foo1.example.org foo2.example.org</userinput>
+<userinput>&COMMANDNAME; --timeout="5m" --interval="1m" foo1.example.org foo2.example.org</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2019-02-11 07:06:55 +0000
+++ plugins.d/askpass-fifo.c	2019-02-11 05:14:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
+ * Copyright © 2008-2018 Teddy Hogeborn
+ * Copyright © 2008-2018 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2019-02-11 07:06:55 +0000
+++ plugins.d/password-prompt.c	2019-02-11 05:14:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
+ * Copyright © 2008-2018 Teddy Hogeborn
+ * Copyright © 2008-2018 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 

